function Router(handler) {
  //Single path points to next router
  this.paths = {};
  //Single path points checking the parameters
  this.parameters = [];
  //Path points that don't care
  this.wildcards = [];
  //Handler for invocation
  handler = handler || null;
}
// Parses the route and adds the appropriate pathing
Router.prototype.add = function add(route, handler) {
  var partsMatcher = /:[a-zA-Z_-]+([(].*?[)])|[*]|[\/]|[^\/]+/g, match;
  while(match = partsMatcher.exec(match)) {
    switch(match[0]) {
      //Parameter
      case ':':

      //Wildcard
      // - Keep iterating till the end (if another route can pick up from there go with it)
      case '*':

      //Subroute
      case '/':

      //Token
      default:
    }
  }
}
// Path to a url-encoded token
Router.prototype.path = function path(token, router) {
  this.paths[token] = router;
}
// Test of the url-encoded token
Router.prototype.param = function param(test, router) {
  this.parameters.push({test: test, router: router});
}
// Find the proper router for a request
Router.prototype.route = function route(url,cb) {
  if(typeof url === 'string') {
    url = url.split('/');
  }
  if(url && url.length) {
    var path = url[0]
    var paths = this.paths;
    if(paths[path]) {
      paths[path].route(url.slice(1),cb);
      return;
    }
    else {
      var params = this.parameters;
      for(var i = 0; i < params.length; i++) {
        var param = params[i];
        if(param.test(path)) {
          param.router.route(url.slice(1),cb);
          return;
        }
      }
      if(handler) {
        cb(false,this);
        return;
      }
    }
  }
  cb(true, this);
  return;
}
